<?php
require_once '../../data/constant.php';
require_once '../../data/db_access.php';
require_once '../../data/table_access.php';

ini_set("session.save_handler","files");
session_start();
if (!isset($_SESSION[SESSION_ADMIN])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."teacher/login.php");
	exit;
}


$ses_arr = $_SESSION[SESSION_ADMIN];
$act_type = "";
$err_msg = "";

$practice_id = "";
$back_file ="";

//񤭹ߥե
$write_img = DOC_ROOT."img_files/";

if ($_POST <> null) {
	if (isset($_POST['action_type'])) {
		if ($_POST['action_type'] == "insert" || $_POST['action_type'] == "update"
		 || $_POST['action_type'] == "from_question") {
			$act_type = $_POST['action_type'];
		}
	}
}

if ($_GET <> null && isset($_GET['action_type'])) {
	$act_type =$_GET['action_type'];
}
$img_dir = "";
if (isset($_SESSION["tmp_img"])) {
	//᡼ξ
	$img_dir = DOC_ROOT."img_files/".$_SESSION["tmp_img"];
	unset($_SESSION["tmp_img"]);
} else if ($act_type == "from_question" && is_numeric($_POST["text_id"])
	&& $_POST["text_id"] <> 0) {
	$img_dir = DOC_ROOT."img_files/".$_POST["text_id"];
}

if ($act_type <> "update" && $act_type <> "insert" && $act_type <> "from_question") {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."admin/login.php");
	exit;
} else {
	$data_object = new CDbAccess();
		//DB³
	if ($data_object->openDB() == false) {
		$err_msg .= $data_object->err_msg;
	} else {
		//ꥪ֥Ȥ
		$prac_object = new CPracTableAccess();
		if (!isset($_POST['ans_txt']) || !is_numeric($_POST['ans_txt'])) {
			$err_msg .= "Irregular Parameter<br/>";
		} else {
			//if ($_POST['ans_txt'] == 0) {
			if ($_POST['ans_txt'] == 0 || $_POST['ans_txt'] == 5) {
				$item_object = new CPracKeyWordTableAccess();
			} else {
				$item_object = new CPracItemTableAccess();
			}
		}

		if ($err_msg == "" && $data_object->transactionBegin()) {
			if ($act_type == "insert" || $act_type == "from_question") {
				if (!$prac_object->insertPracDataFromTeaExe($data_object->conn, $_POST, $ses_arr['teacher_id'])) {
					$err_msg = "Failed to Insert Practice Data<br>";
					$err_msg .= $prac_object->err_msg;
				} else {
					$practice_id = $prac_object->getLatestId("practice_id", $data_object->conn);
				}
			} else if ($act_type == "update" && isset($_POST['up_id']) && is_numeric($_POST['up_id'])) {
				if (!$prac_object->updatePracDataFromTeaExe ($data_object->conn, $_POST)) {
					$err_msg = "Failed to Update Practice Data<br>";
				} else {
					$practice_id = $_POST['up_id'];
					$item_object->deletePracByInsert($data_object->conn, $practice_id);
				}
			}

			if (!is_numeric($practice_id)) {
				$err_msg .= "Irregular Prameter";
			} else {
				//if ($_POST['ans_txt'] == 0) {
				if ($_POST['ans_txt'] == 0 || $_POST['ans_txt'] == 5) {
					for ($i=0; $i< 10; $i++) {
						if (isset($_POST["key_word".$i]) && $_POST["key_word".$i] <> "") {
						if (!$item_object->insertKeywordExe ($data_object->conn, $practice_id,$_POST["key_word".$i])) {
							$err_msg .= "Failed to Insert KeyWord";
							break;
						}
						}
					}
				} else {
					for ($i=0; $i< 10; $i++) {
						if (isset($_POST["item_bango".$i]) && $_POST["item_bango".$i] <> "") {
						if (!$item_object->insertPracItemExe ($data_object->conn,
							$practice_id,
							$_POST["item_bango".$i],
							$_POST["item_txt".$i], $_POST["is_right".$i])) {
							$err_msg .= "";
							break;
						}
						}
					}
				}
			}

			//
			if ($err_msg == "") {
		//顼ʤˤϡեν񤭹
				if ($_POST['img_file'] <> "") {
					if (!mb_ereg("\.gif|\.jpg|\.jpeg|\.png|\.bmp$",$_POST['img_file'])) {
						$err_msg .="File Type Error<br/>";
					} else {
						if (!is_dir($write_img."prac_".$practice_id)) {
							mkdir($write_img."prac_".$practice_id,0777);
						}
						if (is_dir($img_dir)) {
						if (!copy($img_dir."/".$_POST['img_file'], $write_img."prac_".$practice_id."/".$_POST['img_file'])) {
							$err_msg .="᡼ե񤭹߼";
						}
						if ($act_type <> "from_question" && $_POST["text_id"]=="") {
							unlink($img_dir."/".$_POST['img_file']);
							rmdir($img_dir);
						}
						}
					}
				}
			}

			if ($err_msg == "") {
				$data_object->transactionCommit();
			} else {
				$data_object->transactionRollBack();
			}
		}
		$data_object->closeDB();
	}
}
if ($err_msg == "") {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."teacher/practice_reg/");
	exit;
}
echo $err_msg;
?>